VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "modAOL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public Event SignedOn(ScreenName As String)
Public Event JoinChatError(ErrNumber As Integer, ErrString As String)
Public Event RoomRate()

'Declare
Private CurrentChatID As String
Private CurrentChatCache As String
Private ChatID As String
'End Declares

Public Function HandlePacket(Packet As String, Client As Boolean) As String
'Where we parse all the data going through iCOM

    'If we run into an error just resume.
    On Error Resume Next
    
    If Client = True Then
        
        Select Case Mid$(Packet$, 13, 4)
            
            Case "4145"
                'Outgoing class: Chat Send, Ban, Close, UnBan, Ignore, UnIgnore
                sPacket = vbNullString
                
        End Select
        
    Else 'From the server
    
        Select Case Mid$(Packet, 13, 4)
        
            Case "4174"
                'Parse user
                Call ParseUser(Packet$)
                
            Case "6174"
                'Chat data
                
                Select Case Mid$(Packet$, 17, 4)
                    
                    Case "7FE0"
                        'Some room data
                        
                        If InStr(1, Packet$, "54686520726F6F6D20796F75207265717565737465642069732066756C6C") > 0 Then
                            'Looks for room requested is full.
                            
                            RaiseEvent JoinChatError("0", "The room you requested is full.")
                        
                        End If
                        
                        If InStr(1, Packet$, "596F75277665206D61646520746F6F206D616E7920726571756573747320746F6F20717569636B6C792E2020506C6561736520726564756365207468652072617465206F6620796F75722072657175657374732E") > 0 Then
                            'Looks for "rated"
                            
                            RaiseEvent RoomRate
                        
                        End If
                        
                        If InStr(1, Packet$, "57652061726520756E61626C6520746F2070757420796F7520696E207468617420726F6F6D20617420746869732074696D652C206572726F72") > 0 Then
                            'Looks for room reset
                            
                            RaiseEvent JoinChatError("1", "Could not join chatroom.")
                            
                        End If

                    Case "7FE1"
                        'Some room data
                        
                        If Mid$(Packet$, 25, 8) = "20014001" Then
                            'CurrentChatID
                            
                            CurrentChatID$ = Mid$(Packet$, 21, 4)
                        
                        End If
                                                
                End Select
                
        End Select
                            
    End If
    
    HandlePacket$ = Packet$
    
End Function

Private Sub ParseUser(ByVal Packet As String)

    Dim Parse As String, i As Integer

    If InStr(1, Packet, "2001E22D") > 0 Then
    
        Parse$ = Mid$(Packet$, 33, Len(Packet$) - 33)

        Parse$ = DeHex$(Replace(Parse$, "2002", vbNullString))
        
        RaiseEvent SignedOn(Mid$(Parse$, 1, Len(Parse$) - 2))

    ElseIf InStr(1, Packet, "20010D250") > 0 Then
    
        Parse$ = Mid$(Packet$, 33, Len(Packet$) - 33)
    
        Parse$ = DeHex$(Replace(Parse$, "2002", vbNullString))
        
        RaiseEvent SignedOn(Mid$(Parse$, 1, Len(Parse$) - 2))

    End If
    
End Sub

Public Function DeHex(Data As String) As String

    On Error Resume Next
    
    Dim iCount As Double
    
    For iCount = 1 To Len(Data) Step 2
        DeHex = DeHex & Chr$(Val("&H" & Mid$(Data, iCount, 2)))
    Next iCount

End Function

Public Function EnHex(Data As String) As String

    On Error Resume Next
    
    Dim iCount As Double
    Dim sTemp As String
    
    For iCount = 1 To Len(Data)
        sTemp = Hex$(Asc(Mid$(Data, iCount, 1)))
        If Len(sTemp) < 2 Then sTemp = "0" & sTemp
        EnHex = EnHex & sTemp
    Next iCount

End Function

Public Function Hex2Int(Data As String) As String

    On Error Resume Next
    
    Dim iCount As Double

    For iCount = 1 To Len(Data) Step 2
        Hex2Int = Hex2Int & CInt(Val("&H" & Mid$(Data, iCount, 2)))
    Next iCount

End Function

Public Function Int2Hex(Data As String) As String

    On Error Resume Next
    
    Dim sTemp As String

    sTemp = Hex(Data)
    If Len(sTemp) < 2 Then sTemp = "0" & sTemp
    Int2Hex = Int2Hex & sTemp

End Function

Public Function GenRanNum(HighestNum As Long, LowestNum As Long)

    Randomize
    GenRanNum = Int((HighestNum - LowestNum + 1) * Rnd + LowestNum)
    
End Function

Public Function IntegerToBase256(Value As Integer) As String

    IntegerToBase256 = Chr(Int(Value / 256)) & Chr(Value - (Int(Value / 256)) * 256)
    
End Function

Public Function LngToBase256(Value As Long) As String

    LngToBase256 = Chr(Int(Value / 256)) & Chr(Value - (Int(Value / 256)) * 256)
    
End Function

Public Function Hex2LngVar(Data As String, StepLength As Integer) As String

    On Error GoTo Hex2LngVarErr
    Dim iCount As Double
    
    For iCount = 1 To Len(Data) Step StepLength
    
    Hex2LngVar = Hex2LngVar & CLng("&H" & Mid$(Data, iCount, StepLength))
    
    Next iCount
    Exit Function
    
Hex2LngVarErr:
    Hex2LngVar = "Error"
    
End Function

Public Function ShiftRight(ByVal Value As Long, ByVal Bits As Integer) As Long
    
    ShiftRight = Value \ 2 ^ Bits

End Function
