VERSION 5.00
Begin VB.UserControl ctlParser 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Timer Timer1 
      Interval        =   500
      Left            =   240
      Top             =   240
   End
End
Attribute VB_Name = "ctlParser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private MsgQueue As Collection
Private LastMsgTime As Long
Private ChatID As String
Private JoiningChat As Boolean
Private CurrentChatID As String '4 Character long hex chat ID
Private CurrentChatName As String
Private CurrentChatType As String
Private CurrentChatExch As String
Private PeopleHere As Collection
Private EjectList As Collection
Private GettingChatList As Boolean
Private tmpSNhold As String 'For Parser
Private ChatCache As String

'Eject List/People List
Private ChatDataCache As String
Private DataID As String
'End Eject List/People List

'Declare events for UI
Public Event Rated()
Public Event BuddyUpdate(Joined As Boolean, Name As String)
Public Event AutoJoined()
Public Event IncomingChatMessage(Name As String, Message As String)
Public Event JoinedChat(Name As String, Exchange As String, PeopleList As Collection)
Public Event EjectName(Name As String)
Public Event SignedOn(Name As String)

Public Function AnalyzePacket(ByVal sPacket As String, ByVal isClient As Boolean) As String

    On Error Resume Next

    If isClient = True Then
        
        Select Case Mid(sPacket, 13, 4)
        
            Case "4145"
                'Outgoing class: Chat Send, Ban, Close, UnBan, Ignore, UnIgnore
                sPacket = vbNullString
                
        End Select

    Else 'Else it's from the server

            Select Case Mid(sPacket, 13, 4)
                
                Case "4174"
                        
                    Call ParseUser(sPacket$)
                                        
                Case "6174"
                    'Data packets?
                    
                    Select Case Mid(sPacket, 17, 4)

                        Case "0102"
                            
                            sPacket = vbNullString
                            
                        Case "0115"
                            'Packet used to download lists of aol servers and connect numbers
                            'Unneeded, so kill it to save bandwidth
                            sPacket = vbNullString
                        
                        Case "013E"
                            If Mid(sPacket, 21, 4) = "0001" Then
                                'Login data?  (found one at logoff once)
                                If InStr(1, sPacket, "687474703A2F2F616F6C7365617263682E616F6C2E636F6D2F6469727365617263682E6164703F7175657279") > 0 Then
                                    'if its the "http://aolsearch.aol.com/dirsearch.adp?query" string then allow it
                                    'this is the packet that opens the buddy list and allows opening of web pages
                                Else
                                    'Kill any other packets, theyre unneeded
                                    sPacket = vbNullString
                                End If
                            End If
                            
                        Case "7FE0"
                            
                        Case "7FE1"
                            'Chat junk
                            'Don't know if there are any really short
                            'packets of this type, but in case there are...
                            'If Len(sPacket) > 66 Then
                                If Mid(sPacket, 25, 8) = "20014001" Then
                                    'First packet, entering new chat, get ID
                                    CurrentChatID = Mid(sPacket, 21, 4)

                                End If

                                'This section is for getting the user list from the chat, it's the best I could
                                'do on the first try - barely every messes up.
                                'The usersbanned list is sent immediately after this, but I don't parse it because
                                'it's more susceptible to errors, and we really dont need it
                                Select Case Mid(sPacket, 21, 4)
                                    Case CurrentChatID

                                        If InStr(1, sPacket, "616F6C3A2F2F323731393A") > 0 Then
                                            
                                            Call ParseCurrentChat(sPacket)
                                            
                                        End If
                                        
                                        If InStr(1, sPacket, "211D4B16212A6B") > 0 Then
                                            
                                            GettingChatList = True
                                            
                                            ChatDataCache = sPacket

                                        End If
                                        
                                        If InStr(1, sPacket, "0A0A4F6E6C696E65486F7374") > 0 Then
                                            
                                            GettingChatList = False
                                            
                                            ChatDataCache = ChatDataCache + sPacket
                                            
                                            Debug.Print ChatDataCache
                                            
                                            Debug.Print DeHex(ChatDataCache)
                                            
                                            Call HandleChatMP(ChatDataCache)

                                        End If
                                        
                                        If GettingChatList = True Then
                                            
                                            ChatDataCache = ChatDataCache + Mid$(sPacket, 25)
                                            
                                        End If

                                End Select
                            
                                Select Case Mid(sPacket, 25, 38)
                                    Case "20012196130000002F5332334B36214A01000B"
                                        'Join and leave packets for names 8 or more characters long (includes formatting)
                                        If Mid(sPacket, 63, 2) = "20" Then
                                            'Buddy joined chat, first part of body = "20012196130000002F5332334B36214A01000B20"
                                            'Only difference between join and leave is the last byte
                                            RaiseEvent BuddyUpdate(True, DeHex(Mid(sPacket, 67, Hex2Int(Mid(sPacket, 65, 2)) * 2)))
                                        ElseIf Mid(sPacket, 63, 2) = "0E" Then
                                            'Buddy left chat, first part of body = "20012196130000002F5332334B36214A01000B0E"
                                            'Only difference between join and leave is the last byte
                                            RaiseEvent BuddyUpdate(False, DeHex(Mid(sPacket, 67, Hex2Int(Mid(sPacket, 65, 2)) * 2)))
                                        End If
                                    Case "20012196130000002F5332334B36214A0100E2"
                                        'Join packet for names less than 8 characters (includes formatting)
                                        'CRAZY AOL STICK TO ONE PACKET TYPE PER FUNCTION
                                        RaiseEvent BuddyUpdate(True, DeHex(Mid(sPacket, 67, Len(sPacket) - 86)))
                                    Case "20012196130000002F5332334B36214A01002B"
                                        'Leave packet for names less than 8 characters (includes formatting)
                                        'CRAZY AOL STICK TO ONE PACKET TYPE PER FUNCTION
                                        RaiseEvent BuddyUpdate(False, DeHex(Mid(sPacket, 65, Len(sPacket) - 84)))
                                    
                                End Select
                                
                                If Mid$(sPacket$, 21, 4) = ChatID Then
                                    'Continuation
                                    
                                    ChatCache = ChatCache & Mid$(DeHex(sPacket$), 32)
                                    
                                    If InStr(1, sPacket$, "20273241162027332002") > 0 Then
                                        'End of packet
                                        Call ParseChat(ChatCache)
                                        
                                        ChatID = vbNullString
                                        ChatCache = vbNullString
                                        
                                    Else
                                        'Another packet :O
                                        ChatID = Mid$(sPacket$, 21, 4)
                                        
                                    End If
                                
                                Else
                                
                                    If Mid$(sPacket$, 25, "48") = "20012196130000002F533233214A01002B38FF2B79FFFFFF" Then
                                        
                                        If InStr(1, sPacket$, "20273241162027332002") > 0 Then
                                            'One packet :x
                                            
                                            Call ParseChat(DeHex(sPacket$))
                                            
                                        Else
                                            'Two packets x:
                                            
                                            ChatID = Mid$(sPacket$, 21, 4)
                                            
                                            ChatCache = Mid$(DeHex(sPacket$), 1)
                                            
                                        End If
                                    
                                    End If
                                
                                    If JoiningChat = True Then
                                        JoiningChat = False
                                        ChatID = vbNullString
                                        ChatCache = vbNullString
                                    End If
                                End If
                            'End If
                            sPacket = vbNullString

                    End Select

            End Select
            
    End If
    
    AnalyzePacket = sPacket

End Function

Private Sub ParseUser(ByVal Packet As String)

    Dim Parse As String, i As Integer

    If InStr(1, Packet, "2001E22D") > 0 Then
    
        Parse$ = Mid$(Packet$, 33, Len(Packet$) - 33)

        Parse$ = DeHex$(Replace(Parse$, "2002", vbNullString))
        
        RaiseEvent SignedOn(Mid$(Parse$, 1, Len(Parse$) - 2))

    ElseIf InStr(1, Packet, "20010D250") > 0 Then
    
        Parse$ = Mid$(Packet$, 33, Len(Packet$) - 33)
    
        Parse$ = DeHex$(Replace(Parse$, "2002", vbNullString))
        
        RaiseEvent SignedOn(Mid$(Parse$, 1, Len(Parse$) - 2))

    End If
    
End Sub
Public Sub ParseChat(strData As String)
'|||
'||| Parse chat data
'|||

    On Error Resume Next
    
    Dim tmpScreenName As String, tmpChatData As String, tmpData() As String, tmpData2() As String, SNLen As Integer, SNType As Integer, Index As Long
    
    tmpChatData$ = Replace(strData$, DeHex("20273241162027332002"), vbNullString)

    If InStr(1, tmpChatData$, "<html>") > 0 Then
    
        tmpData$ = Split(tmpChatData$, "<html>", 2)
    
        tmpData2$ = Split(tmpData$(1), "</html>", 2)
    
        tmpChatData$ = vbNullString
    
        tmpChatData$ = tmpData2$(0)
    
    ElseIf InStr(1, tmpChatData$, "<HTML>") > 0 Then
    
        tmpData$ = Split(tmpChatData$, "<HTML>", 2)
    
        tmpData2$ = Split(tmpData$(1), "</HTML>", 2)
    
        tmpChatData$ = vbNullString
    
        tmpChatData$ = tmpData2$(0)
    
    End If
    
    Index& = 43

    SNType% = Asc%(Mid$(strData$, Index&, 1))
    
    Index& = Index& + 1

    If (SNType% = &H2B) Then
        
        SNLen% = ShiftRight&(Asc%(Mid$(strData$, Index&, 1)), 5)
        
        Index& = Index& + 1
    
    Else
        
        Index& = Index& + 1
        
        SNLen% = Asc%(Mid$(strData$, Index&, 1))
        
        Index& = Index& + 1
    
    End If

    tmpScreenName$ = Mid$(strData$, Index&, SNLen%)

    tmpData2$ = Split(tmpChatData$, "</BODY></FONT>", 2)
    
    tmpChatData$ = tmpData2$(0)

    RaiseEvent IncomingChatMessage(tmpScreenName$, tmpChatData$)

End Sub

Private Sub ParseChatDataList(ByRef Data As String, ByRef Index As Long, ByRef list As Collection)
    
    Dim First As Byte, Sixth As Byte, Char As String, SN As String
    
    Do
        SN$ = vbNullString
    
        First = Asc%(Mid$(Data$, Index&, 1))
        Index& = Index& + 1
        
        'first byte tells us what kind of sn record this is
        Select Case First
            
            Case &H8C
                
                'this is the most common type, simple length and data
                Length = Asc%(Mid$(Data$, Index&, 1))
                Index& = Index& + 1
                SN$ = Mid$(Data$, Index&, Length)
                Index& = Index& + Length
                
            Case &HB
                
                'this is basically the same, but has an extra byte thrown in
                Length = Asc%(Mid$(Data$, Index& + 1, 1))
                Index& = Index& + 2
                SN$ = Mid$(Data$, Index&, Length)
                Index& = Index& + Length
            
            Case &H20
            
                'this is a multipart sn.
                'took awhile to figure out, but shouldnt error now that ive got it
                
                'sixth byte tells us where to find the length
                Sixth = Asc%(Mid$(Data$, Index& + 4, 1))
                
                If (Sixth = &H0) Then
                    
                    Index& = Index& + 6
                    Length = Asc%(Mid$(Data$, Index&, 1))
                    Index& = Index& + 1
                
                ElseIf (Sixth = &H20) Then
                    
                    Index& = Index& + 5
                    'the length is stored within a byte with some other data
                    'so bitshift to extract it
                    Length = ShiftRight(Asc%(Mid$(Data$, Index&, 1)), 5)
                    Index& = Index& + 1
                
                End If
                
                'read the first part of the sn
                SN$ = Mid$(Data$, Index&, Length)
                Index& = Index& + Length
                
                'this byte here again tells us where the length is (reusing the sixth var)
                Sixth = Asc%(Mid$(Data$, Index&, 1))
                
                If (Sixth = &H0) Then
                    
                    Index& = Index& + 2
                    Length = Asc%(Mid$(Data$, Index&, 1))
                    Index& = Index& + 1
                
                ElseIf (Sixth = &H20) Then
                    
                    Index& = Index& + 1
                    Length = ShiftRight(Asc%(Mid$(Data$, Index&, 1)), 5)
                    Index& = Index& + 1
                
                End If
                
                'read the second part of the sn
                SN$ = SN$ & Mid$(Data$, Index&, Length)
                
                Index& = Index& + Length
            
            Case &H2B
                
                'this is another one that needs the bits shifted to get the length
                Length = ShiftRight(Asc%(Mid$(Data$, Index&, 1)), 5)
                Index& = Index& + 1
                SN$ = Mid$(Data$, Index&, Length)
                Index& = Index& + Length
            
            Case &H21
                
                'end of list
                Exit Do
            
            Case Else
                'something went wrong? i dunno, maybe trap this later
        
        End Select
        
        If SN <> vbNullString Then
            
            list.Add SN, Replace(LCase(SN), " ", vbNullString)
            
            Debug.Print SN
            
        End If

    Loop While (Index& < Len(Data$))
    
End Sub

Private Sub HandleChatData(Data As String)
    
    Dim Index As Long, EndOfList As Boolean, i As Integer

    Index& = InStr(1, Data$, DeHex("211D4B16212A6B"))
    
    Index& = Index& + 7

    Call ParseChatDataList(Data$, Index&, PeopleHere)
        
    Index& = InStr(Index&, Data$, DeHex("1D212A6A"))
    
    If (Index& > 0) Then
        
        Index& = Index& + 4

        Call ParseChatDataList(Data$, Index&, EjectList)

    End If

    Call UpdateEjects
    
    Call UpdatePeople
    
End Sub

Private Sub HandleChatMP(Data As String)
    
    Dim tmpDataSplit() As String, tmpData2Split() As String, tmpFullStr As String

    Set PeopleHere = New Collection
    
    Set EjectList = New Collection
    
    If InStr(1, Data, "211D4B16212A6B") > 0 Then
    
    '   People/eject list first
    
       tmpDataSplit$ = Split(Data$, "211D4B16212A6B", 3)
       
       tmpData2Split$ = Split(tmpDataSplit(2), "3521386C214A")
    
    End If
    
    tmpFullStr = "211D4B16212A6B" & tmpData2Split$(0)
    
    Call HandleChatData(DeHex(tmpFullStr))

End Sub

Public Sub UpdatePeople()
    
    On Error Resume Next
    
    Dim i As Integer

    For i% = 0 To PeopleHere.Count
            
        RaiseEvent BuddyUpdate(True, PeopleHere.Item(i%))
            
    Next i%
    
End Sub

Public Sub UpdateEjects()
    
    On Error Resume Next
    
    Dim i As Integer

    For i% = 0 To EjectList.Count
        
        RaiseEvent EjectName(PeopleHere.Item(i%))
        
    Next i%
    
End Sub

Public Sub ParseCurrentChat(sPacket As String)

    Dim tmpData() As String, tmpData2() As String, tmpData3() As String
    
    tmpData$ = Split(sPacket$, "616F6C3A2F2F323731393A", 2)
    
    tmpData2$ = Split(tmpData$(1), "10AF002E9F00046225", 2)
    
    tmpData3$ = Split(tmpData2$(0), "2D", 3)

    CurrentChatType = DeHex(tmpData3$(0))
    
    CurrentChatExch = DeHex(tmpData3$(1))
    
    CurrentChatName = DeHex(tmpData3$(2))
    
    RaiseEvent JoinedChat(CurrentChatName, CurrentChatExch)
    
End Sub

Public Sub SendToChat(ByVal Message As String, Optional CheckLen As Boolean = True)
'|||
'||| Send a message to the chat
'|||
    
    On Error Resume Next
    
    If CurrentChatID$ = vbNullString Then Exit Sub
    
    If CheckLen = True Then
        If Len(Message$) > 232 Then Exit Sub
    End If

    If LastMsgTime + 1 < Timer Or Timer + 1 < LastMsgTime Then
        'Ready
        LastMsgTime = Timer
    
        Dim tmpPacket As String, tmpStr As String, tmpStr2 As String, tmpID As String
        Dim PacketNum As String
        
        tmpStr$ = Message
        
        tmpID = IntegerToBase256(GenRanNum(2200, 400))
        
        If Len(tmpStr) > 90 Then
            'Multi Packets
            tmpStr2 = Mid(tmpStr, 1, 76)
            tmpStr = Mid(tmpStr, 77)
            
            tmpPacket = DeHex("4145") & tmpID & DeHex("0001000107040000000A030B0400000001010A040000006C00040203010005") & Chr(Len(tmpStr2)) & tmpStr2
            tmpPacket = DeHex("2A020000") & IntegerToBase256(Len(tmpPacket)) & tmpPacket
            tmpPacket = EnHex(tmpPacket)
            
            Call frmMain.ctlAOLProxy1.ProxySendServer(tmpPacket)
            
            Do While Len(tmpStr) > 0
                If Len(tmpStr) > 112 Then
                    PacketNum = "0005"
                    tmpStr2 = Mid(tmpStr, 1, 112)
                    tmpStr = Mid(tmpStr, 113)
                    tmpPacket = DeHex("4145") & tmpID & DeHex(PacketNum) & Chr(Len(tmpStr2)) & tmpStr2
                Else
                    PacketNum = "0006"
                    tmpStr2 = tmpStr
                    tmpStr = vbNullString
                    tmpPacket = DeHex("4145") & tmpID & DeHex(PacketNum) & Chr(Len(tmpStr2)) & tmpStr2 & DeHex("011D00000200")
                End If
                
                tmpPacket = DeHex("2A020000") & IntegerToBase256(Len(tmpPacket)) & tmpPacket
                tmpPacket = EnHex(tmpPacket)
                
                Call frmMain.ctlAOLProxy1.ProxySendServer(tmpPacket)
            Loop
        
        Else
            'Single Packet
            
            tmpPacket = DeHex("4145") & tmpID & DeHex("0001000107040000000A030B0400000001010A040000006C00040203010005") & Chr(Len(tmpStr)) & tmpStr & DeHex("011D00000200")
            tmpPacket = DeHex("2A020000") & IntegerToBase256(Len(tmpPacket)) & tmpPacket
            tmpPacket = EnHex(tmpPacket)
            
            Call frmMain.ctlAOLProxy1.ProxySendServer(tmpPacket)
            
        End If
    
    Else
        'Makes sure we dont add the same twice (help and stuff)
        MsgQueue.Add Message, Message
        
    End If
    
End Sub

Public Sub JoinChat(Chatname As String, Optional Exchange As String = 4, Optional ChatType As String = "10")
'|||
'||| Joins a chat
'|||

    On Error Resume Next
    
    Dim tmpPacket As String, tmpRanNum As String

    tmpRanNum = IntegerToBase256(GenRanNum(2200, 400))
    
    tmpPacket = DeHex("7572") & tmpRanNum & DeHex("00010000") & LngToBase256(Len(Replace(LCase(Chatname), " ", vbNullString)) + 3600) & DeHex("616F6C3A2F2F323731393A" & EnHex(ChatType) & "2D" & EnHex(Exchange) & "2D") & Chatname & DeHex("000200")

    tmpPacket = DeHex("2A020000") & IntegerToBase256(Len(tmpPacket)) & tmpPacket
    
    tmpPacket = EnHex(tmpPacket)
    
    Call frmMain.ctlAOLProxy1.ProxySendServer(tmpPacket)

End Sub

Public Sub LeaveChat()
'|||
'||| Leaves a chat
'|||

    On Error Resume Next

    Set PeopleHere = New Collection
    
    Set EjectList = New Collection
    
    Call UpdatePeople
    
    Call UpdateEjects

    tmpPacket = "2A02000000197244" & EnHex(IntegerToBase256(GenRanNum(2200, 400))) & "000100030001010304010103010400000000000200"
    
    Call frmMain.ctlAOLProxy1.ProxySendServer(tmpPacket)
    
    CurrentChatID = vbNullString

End Sub

Private Sub Timer1_Timer()
    
    On Error Resume Next
    'Set msgQueue = New Collection
    If MsgQueue.Count > 0 Then
        If LastMsgTime + 1 < Timer Or Timer + 1 < LastMsgTime Then
            Call SendToChat(MsgQueue.Item(1), False)
            MsgQueue.Remove (1)
        End If
    End If
    
End Sub

Private Sub UserControl_Initialize()
    
    Set MsgQueue = New Collection
    
End Sub

